
package net.mcreator.enderitestuff.client.renderer;

import net.minecraft.resources.ResourceLocation;
import net.minecraft.client.renderer.entity.state.LivingEntityRenderState;
import net.minecraft.client.renderer.entity.MobRenderer;
import net.minecraft.client.renderer.entity.EntityRendererProvider;

import net.mcreator.enderitestuff.entity.CaveCrawlerEntity;
import net.mcreator.enderitestuff.client.model.ModelCaveCrawler;

public class CaveCrawlerRenderer extends MobRenderer<CaveCrawlerEntity, LivingEntityRenderState, ModelCaveCrawler> {
	private CaveCrawlerEntity entity = null;

	public CaveCrawlerRenderer(EntityRendererProvider.Context context) {
		super(context, new ModelCaveCrawler(context.bakeLayer(ModelCaveCrawler.LAYER_LOCATION)), 0.5f);
	}

	@Override
	public LivingEntityRenderState createRenderState() {
		return new LivingEntityRenderState();
	}

	@Override
	public void extractRenderState(CaveCrawlerEntity entity, LivingEntityRenderState state, float partialTicks) {
		super.extractRenderState(entity, state, partialTicks);
		this.entity = entity;
	}

	@Override
	public ResourceLocation getTextureLocation(LivingEntityRenderState state) {
		return ResourceLocation.parse("enderite__stuff:textures/entities/white.png");
	}
}
