
package net.mcreator.enderitestuff.client.renderer;

import net.minecraft.resources.ResourceLocation;
import net.minecraft.client.renderer.entity.state.LivingEntityRenderState;
import net.minecraft.client.renderer.entity.MobRenderer;
import net.minecraft.client.renderer.entity.EntityRendererProvider;

import net.mcreator.enderitestuff.entity.GrenadeEntity;
import net.mcreator.enderitestuff.client.model.ModelFragGrenadeNew_Converted;

public class GrenadeRenderer extends MobRenderer<GrenadeEntity, LivingEntityRenderState, ModelFragGrenadeNew_Converted> {
	private GrenadeEntity entity = null;

	public GrenadeRenderer(EntityRendererProvider.Context context) {
		super(context, new ModelFragGrenadeNew_Converted(context.bakeLayer(ModelFragGrenadeNew_Converted.LAYER_LOCATION)), 0.1f);
	}

	@Override
	public LivingEntityRenderState createRenderState() {
		return new LivingEntityRenderState();
	}

	@Override
	public void extractRenderState(GrenadeEntity entity, LivingEntityRenderState state, float partialTicks) {
		super.extractRenderState(entity, state, partialTicks);
		this.entity = entity;
	}

	@Override
	public ResourceLocation getTextureLocation(LivingEntityRenderState state) {
		return ResourceLocation.parse("enderite__stuff:textures/entities/nadetrown.png");
	}
}
