
package net.mcreator.enderitestuff.client.screens;

import org.checkerframework.checker.units.qual.h;

import net.neoforged.neoforge.client.event.RenderGuiEvent;
import net.neoforged.fml.common.EventBusSubscriber;
import net.neoforged.bus.api.SubscribeEvent;
import net.neoforged.bus.api.EventPriority;
import net.neoforged.api.distmarker.Dist;

import net.minecraft.world.level.Level;
import net.minecraft.world.entity.player.Player;
import net.minecraft.resources.ResourceLocation;
import net.minecraft.client.renderer.RenderType;
import net.minecraft.client.renderer.CoreShaders;
import net.minecraft.client.Minecraft;

import net.mcreator.enderitestuff.procedures.PAOverlayShowProcedure;
import net.mcreator.enderitestuff.procedures.Heatbarcontrol90Procedure;
import net.mcreator.enderitestuff.procedures.Heatbarcontrol80Procedure;
import net.mcreator.enderitestuff.procedures.Heatbarcontrol70Procedure;
import net.mcreator.enderitestuff.procedures.Heatbarcontrol60Procedure;
import net.mcreator.enderitestuff.procedures.Heatbarcontrol50Procedure;
import net.mcreator.enderitestuff.procedures.Heatbarcontrol40Procedure;
import net.mcreator.enderitestuff.procedures.Heatbarcontrol30Procedure;
import net.mcreator.enderitestuff.procedures.Heatbarcontrol20Procedure;
import net.mcreator.enderitestuff.procedures.Heatbarcontrol10Procedure;
import net.mcreator.enderitestuff.procedures.Heatbarcontrol100Procedure;
import net.mcreator.enderitestuff.procedures.Heatbarcontrol0Procedure;
import net.mcreator.enderitestuff.procedures.Ebarcontrol90Procedure;
import net.mcreator.enderitestuff.procedures.Ebarcontrol80Procedure;
import net.mcreator.enderitestuff.procedures.Ebarcontrol70Procedure;
import net.mcreator.enderitestuff.procedures.Ebarcontrol60Procedure;
import net.mcreator.enderitestuff.procedures.Ebarcontrol50Procedure;
import net.mcreator.enderitestuff.procedures.Ebarcontrol40Procedure;
import net.mcreator.enderitestuff.procedures.Ebarcontrol30Procedure;
import net.mcreator.enderitestuff.procedures.Ebarcontrol20Procedure;
import net.mcreator.enderitestuff.procedures.Ebarcontrol10Procedure;
import net.mcreator.enderitestuff.procedures.Ebarcontrol100Procedure;
import net.mcreator.enderitestuff.procedures.Ebarcontrol0Procedure;
import net.mcreator.enderitestuff.procedures.CursorShowProcedure;

import com.mojang.blaze3d.systems.RenderSystem;
import com.mojang.blaze3d.platform.GlStateManager;

@EventBusSubscriber({Dist.CLIENT})
public class PowerArmorOverlayOverlay {
	@SubscribeEvent(priority = EventPriority.NORMAL)
	public static void eventHandler(RenderGuiEvent.Pre event) {
		int w = event.getGuiGraphics().guiWidth();
		int h = event.getGuiGraphics().guiHeight();
		Level world = null;
		double x = 0;
		double y = 0;
		double z = 0;
		Player entity = Minecraft.getInstance().player;
		if (entity != null) {
			world = entity.level();
			x = entity.getX();
			y = entity.getY();
			z = entity.getZ();
		}
		RenderSystem.disableDepthTest();
		RenderSystem.depthMask(false);
		RenderSystem.enableBlend();
		RenderSystem.setShader(CoreShaders.POSITION_TEX);
		RenderSystem.blendFuncSeparate(GlStateManager.SourceFactor.SRC_ALPHA, GlStateManager.DestFactor.ONE_MINUS_SRC_ALPHA, GlStateManager.SourceFactor.ONE, GlStateManager.DestFactor.ZERO);
		RenderSystem.setShaderColor(1, 1, 1, 1);
		if (PAOverlayShowProcedure.execute(entity)) {
			event.getGuiGraphics().blit(RenderType::guiTextured, ResourceLocation.parse("enderite__stuff:textures/screens/guiblue.png"), 0, 0, 0, 0, w, h, w, h);
			if (Ebarcontrol0Procedure.execute(entity)) {
				event.getGuiGraphics().blit(RenderType::guiTextured, ResourceLocation.parse("enderite__stuff:textures/screens/ebar0.png"), w / 2 + -207, h / 2 + 50, 0, 0, 64, 64, 64, 64);
			}
			if (Ebarcontrol10Procedure.execute(entity)) {
				event.getGuiGraphics().blit(RenderType::guiTextured, ResourceLocation.parse("enderite__stuff:textures/screens/ebar10.png"), w / 2 + -207, h / 2 + 50, 0, 0, 64, 64, 64, 64);
			}
			if (Ebarcontrol20Procedure.execute(entity)) {
				event.getGuiGraphics().blit(RenderType::guiTextured, ResourceLocation.parse("enderite__stuff:textures/screens/ebar20.png"), w / 2 + -207, h / 2 + 50, 0, 0, 64, 64, 64, 64);
			}
			if (Ebarcontrol30Procedure.execute(entity)) {
				event.getGuiGraphics().blit(RenderType::guiTextured, ResourceLocation.parse("enderite__stuff:textures/screens/ebar30.png"), w / 2 + -207, h / 2 + 50, 0, 0, 64, 64, 64, 64);
			}
			if (Ebarcontrol40Procedure.execute(entity)) {
				event.getGuiGraphics().blit(RenderType::guiTextured, ResourceLocation.parse("enderite__stuff:textures/screens/ebar40.png"), w / 2 + -207, h / 2 + 50, 0, 0, 64, 64, 64, 64);
			}
			if (Ebarcontrol50Procedure.execute(entity)) {
				event.getGuiGraphics().blit(RenderType::guiTextured, ResourceLocation.parse("enderite__stuff:textures/screens/ebar50.png"), w / 2 + -207, h / 2 + 50, 0, 0, 64, 64, 64, 64);
			}
			if (Ebarcontrol60Procedure.execute(entity)) {
				event.getGuiGraphics().blit(RenderType::guiTextured, ResourceLocation.parse("enderite__stuff:textures/screens/ebar60.png"), w / 2 + -207, h / 2 + 50, 0, 0, 64, 64, 64, 64);
			}
			if (Ebarcontrol70Procedure.execute(entity)) {
				event.getGuiGraphics().blit(RenderType::guiTextured, ResourceLocation.parse("enderite__stuff:textures/screens/ebar70.png"), w / 2 + -207, h / 2 + 50, 0, 0, 64, 64, 64, 64);
			}
			if (Ebarcontrol80Procedure.execute(entity)) {
				event.getGuiGraphics().blit(RenderType::guiTextured, ResourceLocation.parse("enderite__stuff:textures/screens/ebar80.png"), w / 2 + -207, h / 2 + 50, 0, 0, 64, 64, 64, 64);
			}
			if (Ebarcontrol90Procedure.execute(entity)) {
				event.getGuiGraphics().blit(RenderType::guiTextured, ResourceLocation.parse("enderite__stuff:textures/screens/ebar90.png"), w / 2 + -207, h / 2 + 50, 0, 0, 64, 64, 64, 64);
			}
			if (Ebarcontrol100Procedure.execute(entity)) {
				event.getGuiGraphics().blit(RenderType::guiTextured, ResourceLocation.parse("enderite__stuff:textures/screens/ebar100.png"), w / 2 + -207, h / 2 + 50, 0, 0, 64, 64, 64, 64);
			}
			if (Heatbarcontrol0Procedure.execute(entity)) {
				event.getGuiGraphics().blit(RenderType::guiTextured, ResourceLocation.parse("enderite__stuff:textures/screens/heatbar0.png"), w / 2 + -189, h / 2 + 50, 0, 0, 64, 64, 64, 64);
			}
			if (Heatbarcontrol10Procedure.execute(entity)) {
				event.getGuiGraphics().blit(RenderType::guiTextured, ResourceLocation.parse("enderite__stuff:textures/screens/heatbar10.png"), w / 2 + -189, h / 2 + 50, 0, 0, 64, 64, 64, 64);
			}
			if (Heatbarcontrol20Procedure.execute(entity)) {
				event.getGuiGraphics().blit(RenderType::guiTextured, ResourceLocation.parse("enderite__stuff:textures/screens/heatbar20.png"), w / 2 + -189, h / 2 + 50, 0, 0, 64, 64, 64, 64);
			}
			if (Heatbarcontrol30Procedure.execute(entity)) {
				event.getGuiGraphics().blit(RenderType::guiTextured, ResourceLocation.parse("enderite__stuff:textures/screens/heatbar30.png"), w / 2 + -189, h / 2 + 50, 0, 0, 64, 64, 64, 64);
			}
			if (Heatbarcontrol40Procedure.execute(entity)) {
				event.getGuiGraphics().blit(RenderType::guiTextured, ResourceLocation.parse("enderite__stuff:textures/screens/heatbar40.png"), w / 2 + -189, h / 2 + 50, 0, 0, 64, 64, 64, 64);
			}
			if (Heatbarcontrol50Procedure.execute(entity)) {
				event.getGuiGraphics().blit(RenderType::guiTextured, ResourceLocation.parse("enderite__stuff:textures/screens/heatbar50.png"), w / 2 + -189, h / 2 + 50, 0, 0, 64, 64, 64, 64);
			}
			if (Heatbarcontrol60Procedure.execute(entity)) {
				event.getGuiGraphics().blit(RenderType::guiTextured, ResourceLocation.parse("enderite__stuff:textures/screens/heatbar60.png"), w / 2 + -189, h / 2 + 50, 0, 0, 64, 64, 64, 64);
			}
			if (Heatbarcontrol70Procedure.execute(entity)) {
				event.getGuiGraphics().blit(RenderType::guiTextured, ResourceLocation.parse("enderite__stuff:textures/screens/heatbar70.png"), w / 2 + -189, h / 2 + 50, 0, 0, 64, 64, 64, 64);
			}
			if (Heatbarcontrol80Procedure.execute(entity)) {
				event.getGuiGraphics().blit(RenderType::guiTextured, ResourceLocation.parse("enderite__stuff:textures/screens/heatbar80.png"), w / 2 + -189, h / 2 + 50, 0, 0, 64, 64, 64, 64);
			}
			if (Heatbarcontrol90Procedure.execute(entity)) {
				event.getGuiGraphics().blit(RenderType::guiTextured, ResourceLocation.parse("enderite__stuff:textures/screens/heatbar90.png"), w / 2 + -189, h / 2 + 50, 0, 0, 64, 64, 64, 64);
			}
			if (Heatbarcontrol100Procedure.execute(entity)) {
				event.getGuiGraphics().blit(RenderType::guiTextured, ResourceLocation.parse("enderite__stuff:textures/screens/heatbar100.png"), w / 2 + -189, h / 2 + 50, 0, 0, 64, 64, 64, 64);
			}
			if (CursorShowProcedure.execute(entity)) {
				event.getGuiGraphics().blit(RenderType::guiTextured, ResourceLocation.parse("enderite__stuff:textures/screens/cursormodifier.png"), w / 2 + -9, h / 2 + -10, 0, 0, 19, 19, 19, 19);
			}
		}
		RenderSystem.depthMask(true);
		RenderSystem.defaultBlendFunc();
		RenderSystem.enableDepthTest();
		RenderSystem.disableBlend();
		RenderSystem.setShaderColor(1, 1, 1, 1);
	}
}
