
/*
 *    MCreator note: This file will be REGENERATED on each build.
 */
package net.mcreator.enderitestuff.init;

import net.neoforged.neoforge.registries.DeferredRegister;
import net.neoforged.neoforge.registries.DeferredHolder;
import net.neoforged.neoforge.event.entity.EntityAttributeModificationEvent;
import net.neoforged.fml.common.EventBusSubscriber;
import net.neoforged.bus.api.SubscribeEvent;

import net.minecraft.world.entity.ai.attributes.RangedAttribute;
import net.minecraft.world.entity.ai.attributes.Attribute;
import net.minecraft.world.entity.EntityType;
import net.minecraft.core.registries.BuiltInRegistries;

import net.mcreator.enderitestuff.EnderiteStuffMod;

@EventBusSubscriber(bus = EventBusSubscriber.Bus.MOD)
public class EnderiteStuffModAttributes {
	public static final DeferredRegister<Attribute> REGISTRY = DeferredRegister.create(BuiltInRegistries.ATTRIBUTE, EnderiteStuffMod.MODID);
	public static final DeferredHolder<Attribute, Attribute> DEV_COOLDOWN_MODIFIER = REGISTRY.register("dev_cooldown_modifier", () -> new RangedAttribute("attribute.enderite__stuff.dev_cooldown_modifier", 0, 0, 1).setSyncable(true));
	public static final DeferredHolder<Attribute, Attribute> JETPACK_FLY = REGISTRY.register("jetpack_fly", () -> new RangedAttribute("attribute.enderite__stuff.jetpack_fly", 0, 0, 1).setSyncable(true));

	@SubscribeEvent
	public static void addAttributes(EntityAttributeModificationEvent event) {
		event.add(EntityType.PLAYER, DEV_COOLDOWN_MODIFIER);
		event.add(EntityType.PLAYER, JETPACK_FLY);
	}
}
