
/*
 * MCreator note: This file will be REGENERATED on each build.
 */
package net.mcreator.enderitestuff.init;

import net.neoforged.neoforge.registries.DeferredRegister;
import net.neoforged.neoforge.registries.DeferredHolder;
import net.neoforged.fml.event.lifecycle.FMLClientSetupEvent;
import net.neoforged.fml.common.EventBusSubscriber;
import net.neoforged.bus.api.SubscribeEvent;
import net.neoforged.api.distmarker.Dist;

import net.minecraft.world.level.material.Fluid;
import net.minecraft.world.level.material.FlowingFluid;
import net.minecraft.core.registries.BuiltInRegistries;
import net.minecraft.client.renderer.RenderType;
import net.minecraft.client.renderer.ItemBlockRenderTypes;

import net.mcreator.enderitestuff.fluid.DarkMatterFluid;
import net.mcreator.enderitestuff.EnderiteStuffMod;

public class EnderiteStuffModFluids {
	public static final DeferredRegister<Fluid> REGISTRY = DeferredRegister.create(BuiltInRegistries.FLUID, EnderiteStuffMod.MODID);
	public static final DeferredHolder<Fluid, FlowingFluid> DARK_MATTER = REGISTRY.register("dark_matter", () -> new DarkMatterFluid.Source());
	public static final DeferredHolder<Fluid, FlowingFluid> FLOWING_DARK_MATTER = REGISTRY.register("flowing_dark_matter", () -> new DarkMatterFluid.Flowing());

	@EventBusSubscriber(bus = EventBusSubscriber.Bus.MOD, value = Dist.CLIENT)
	public static class FluidsClientSideHandler {
		@SubscribeEvent
		public static void clientSetup(FMLClientSetupEvent event) {
			ItemBlockRenderTypes.setRenderLayer(DARK_MATTER.get(), RenderType.translucent());
			ItemBlockRenderTypes.setRenderLayer(FLOWING_DARK_MATTER.get(), RenderType.translucent());
		}
	}
}
