package net.mcreator.enderitestuff.procedures;

import net.minecraft.world.level.LevelAccessor;
import net.minecraft.world.entity.EntitySpawnReason;
import net.minecraft.world.entity.Entity;
import net.minecraft.server.level.ServerLevel;
import net.minecraft.core.BlockPos;

import net.mcreator.enderitestuff.init.EnderiteStuffModEntities;
import net.mcreator.enderitestuff.init.EnderiteStuffModBlocks;
import net.mcreator.enderitestuff.EnderiteStuffMod;

public class SpikeTrapActivateProcedure {
	public static void execute(LevelAccessor world, double x, double y, double z) {
		world.setBlock(BlockPos.containing(x, y, z), EnderiteStuffModBlocks.SPIKE_TRAP_ACTIVE.get().defaultBlockState(), 3);
		if (world instanceof ServerLevel _level) {
			Entity entityToSpawn = EnderiteStuffModEntities.SPIKE.get().spawn(_level, BlockPos.containing(x, y, z), EntitySpawnReason.MOB_SUMMONED);
			if (entityToSpawn != null) {
				entityToSpawn.setYRot(world.getRandom().nextFloat() * 360F);
			}
		}
		EnderiteStuffMod.queueServerWork(60, () -> {
			world.setBlock(BlockPos.containing(x, y, z), EnderiteStuffModBlocks.SPIKE_TRAP.get().defaultBlockState(), 3);
		});
	}
}
