
package net.mcreator.enderitestuff.block;

import net.minecraft.world.phys.shapes.VoxelShape;
import net.minecraft.world.phys.shapes.Shapes;
import net.minecraft.world.phys.shapes.CollisionContext;
import net.minecraft.world.phys.BlockHitResult;
import net.minecraft.world.level.block.state.BlockState;
import net.minecraft.world.level.block.state.BlockBehaviour;
import net.minecraft.world.level.block.SoundType;
import net.minecraft.world.level.block.Block;
import net.minecraft.world.level.Level;
import net.minecraft.world.level.BlockGetter;
import net.minecraft.world.entity.player.Player;
import net.minecraft.world.InteractionResult;
import net.minecraft.core.Direction;
import net.minecraft.core.BlockPos;

import net.mcreator.enderitestuff.procedures.BossSummonBlockSummonProcedure;

public class BossSummonBlockBlock extends Block {
	public BossSummonBlockBlock(BlockBehaviour.Properties properties) {
		super(properties.sound(SoundType.METAL).strength(-1, 3600000).noOcclusion().isRedstoneConductor((bs, br, bp) -> false));
	}

	@Override
	public boolean propagatesSkylightDown(BlockState state) {
		return true;
	}

	@Override
	public int getLightBlock(BlockState state) {
		return 0;
	}

	@Override
	public VoxelShape getVisualShape(BlockState state, BlockGetter world, BlockPos pos, CollisionContext context) {
		return Shapes.empty();
	}

	@Override
	public VoxelShape getShape(BlockState state, BlockGetter world, BlockPos pos, CollisionContext context) {
		return Shapes.or(box(0, 0, 0, 16, 10, 16), box(-1, 10, -1, 1, 14, 1), box(-1, 10, 1, 1, 12, 15), box(-1, 10, 15, 1, 14, 17), box(1, 10, -1, 15, 12, 1), box(1, 10, 15, 15, 12, 17), box(15, 10, -1, 17, 14, 1), box(15, 10, 1, 17, 12, 15),
				box(15, 10, 15, 17, 14, 17), box(0, 11, -1, 16, 13, 1), box(0, 11, 15, 16, 13, 17), box(-1, 11, 0, 1, 13, 16), box(15, 11, 0, 17, 13, 16));
	}

	@Override
	public InteractionResult useWithoutItem(BlockState blockstate, Level world, BlockPos pos, Player entity, BlockHitResult hit) {
		super.useWithoutItem(blockstate, world, pos, entity, hit);
		int x = pos.getX();
		int y = pos.getY();
		int z = pos.getZ();
		double hitX = hit.getLocation().x;
		double hitY = hit.getLocation().y;
		double hitZ = hit.getLocation().z;
		Direction direction = hit.getDirection();
		BossSummonBlockSummonProcedure.execute(world, x, y, z, entity);
		return InteractionResult.SUCCESS;
	}
}
