
package net.mcreator.enderitestuff.block;

import org.checkerframework.checker.units.qual.s;

import net.minecraft.world.level.material.PushReaction;
import net.minecraft.world.level.material.MapColor;
import net.minecraft.world.level.block.state.BlockState;
import net.minecraft.world.level.block.state.BlockBehaviour;
import net.minecraft.world.level.block.SoundType;
import net.minecraft.world.level.block.LiquidBlock;

import net.mcreator.enderitestuff.init.EnderiteStuffModFluids;

public class DarkMatterBlock extends LiquidBlock {
	public DarkMatterBlock(BlockBehaviour.Properties properties) {
		super(EnderiteStuffModFluids.DARK_MATTER.get(), properties.mapColor(MapColor.COLOR_BLACK).strength(100f).hasPostProcess((bs, br, bp) -> true).emissiveRendering((bs, br, bp) -> true).lightLevel(s -> 1).noCollission().noLootTable().liquid()
				.pushReaction(PushReaction.DESTROY).sound(SoundType.EMPTY).replaceable());
	}

	@Override
	public int getLightBlock(BlockState state) {
		return 14;
	}
}
