
package net.mcreator.enderitestuff.block;

import net.minecraft.world.level.block.state.BlockState;
import net.minecraft.world.level.block.state.BlockBehaviour;
import net.minecraft.world.level.block.SoundType;
import net.minecraft.world.level.block.FallingBlock;

import com.mojang.serialization.MapCodec;

public class VoidSandBlock extends FallingBlock {
	public static final MapCodec<VoidSandBlock> CODEC = simpleCodec(VoidSandBlock::new);

	public MapCodec<VoidSandBlock> codec() {
		return CODEC;
	}

	public VoidSandBlock(BlockBehaviour.Properties properties) {
		super(properties.sound(SoundType.SAND).strength(1f));
	}

	@Override
	public int getLightBlock(BlockState state) {
		return 15;
	}
}
