package net.mcreator.enderitestuff.client.model;

import net.minecraft.resources.ResourceLocation;
import net.minecraft.client.renderer.entity.state.LivingEntityRenderState;
import net.minecraft.client.model.geom.builders.PartDefinition;
import net.minecraft.client.model.geom.builders.MeshDefinition;
import net.minecraft.client.model.geom.builders.LayerDefinition;
import net.minecraft.client.model.geom.builders.CubeListBuilder;
import net.minecraft.client.model.geom.builders.CubeDeformation;
import net.minecraft.client.model.geom.PartPose;
import net.minecraft.client.model.geom.ModelPart;
import net.minecraft.client.model.geom.ModelLayerLocation;
import net.minecraft.client.model.EntityModel;

// Made with Blockbench 4.12.3
// Exported for Minecraft version 1.17 or later with Mojang mappings
// Paste this class into your mod and generate all required imports
public class ModelCaveCrawler extends EntityModel<LivingEntityRenderState> {
	// This layer location should be baked with EntityRendererProvider.Context in
	// the entity renderer and passed into this model's constructor
	public static final ModelLayerLocation LAYER_LOCATION = new ModelLayerLocation(ResourceLocation.fromNamespaceAndPath("enderite__stuff", "model_cave_crawler"), "main");
	public final ModelPart legleftfront;
	public final ModelPart legrightfront;
	public final ModelPart legleftback;
	public final ModelPart legrightback;
	public final ModelPart body;
	public final ModelPart topshell;
	public final ModelPart bottomshell;
	public final ModelPart head;

	public ModelCaveCrawler(ModelPart root) {
		super(root);
		this.legleftfront = root.getChild("legleftfront");
		this.legrightfront = root.getChild("legrightfront");
		this.legleftback = root.getChild("legleftback");
		this.legrightback = root.getChild("legrightback");
		this.body = root.getChild("body");
		this.topshell = this.body.getChild("topshell");
		this.bottomshell = this.body.getChild("bottomshell");
		this.head = root.getChild("head");
	}

	public static LayerDefinition createBodyLayer() {
		MeshDefinition meshdefinition = new MeshDefinition();
		PartDefinition partdefinition = meshdefinition.getRoot();
		PartDefinition legleftfront = partdefinition.addOrReplaceChild("legleftfront", CubeListBuilder.create(), PartPose.offset(9.0F, 19.5F, -8.5F));
		PartDefinition cube_r1 = legleftfront.addOrReplaceChild("cube_r1", CubeListBuilder.create().texOffs(0, 123).addBox(-0.7643F, -2.4234F, -2.5942F, 7.0F, 5.0F, 5.0F, new CubeDeformation(0.0F)),
				PartPose.offsetAndRotation(5.9375F, -1.25F, -2.125F, -0.5236F, 0.0F, 1.5708F));
		PartDefinition cube_r2 = legleftfront.addOrReplaceChild("cube_r2", CubeListBuilder.create().texOffs(0, 133).addBox(-2.5F, -5.0F, -2.5F, 5.0F, 5.0F, 5.0F, new CubeDeformation(0.0F)),
				PartPose.offsetAndRotation(4.5F, 1.4375F, -1.4375F, 0.1339F, 0.4623F, 0.2934F));
		PartDefinition cube_r3 = legleftfront.addOrReplaceChild("cube_r3", CubeListBuilder.create().texOffs(96, 125).addBox(-1.0F, -2.5F, -3.5F, 7.0F, 5.0F, 5.0F, new CubeDeformation(0.0F)),
				PartPose.offsetAndRotation(0.0F, 0.0F, 1.0F, -0.0631F, 0.3435F, -0.1855F));
		PartDefinition legrightfront = partdefinition.addOrReplaceChild("legrightfront", CubeListBuilder.create(), PartPose.offset(-9.0F, 19.5F, -8.5F));
		PartDefinition cube_r4 = legrightfront.addOrReplaceChild("cube_r4", CubeListBuilder.create().texOffs(72, 125).addBox(-6.2357F, -2.4234F, -2.5942F, 7.0F, 5.0F, 5.0F, new CubeDeformation(0.0F)),
				PartPose.offsetAndRotation(-5.9375F, -1.25F, -2.125F, -0.5236F, 0.0F, -1.5708F));
		PartDefinition cube_r5 = legrightfront.addOrReplaceChild("cube_r5", CubeListBuilder.create().texOffs(60, 135).addBox(-2.5F, -5.0F, -2.5F, 5.0F, 5.0F, 5.0F, new CubeDeformation(0.0F)),
				PartPose.offsetAndRotation(-4.5F, 1.4375F, -1.4375F, 0.1339F, -0.4623F, -0.2934F));
		PartDefinition cube_r6 = legrightfront.addOrReplaceChild("cube_r6", CubeListBuilder.create().texOffs(132, 36).addBox(-6.0F, -2.5F, -3.5F, 7.0F, 5.0F, 5.0F, new CubeDeformation(0.0F)),
				PartPose.offsetAndRotation(0.0F, 0.0F, 1.0F, -0.0631F, -0.3435F, 0.1855F));
		PartDefinition legleftback = partdefinition.addOrReplaceChild("legleftback", CubeListBuilder.create(), PartPose.offset(9.0F, 19.5F, 9.5F));
		PartDefinition cube_r7 = legleftback.addOrReplaceChild("cube_r7", CubeListBuilder.create().texOffs(24, 125).addBox(-0.7643F, -2.4234F, -2.4058F, 7.0F, 5.0F, 5.0F, new CubeDeformation(0.0F)),
				PartPose.offsetAndRotation(5.9375F, -1.25F, 2.125F, 0.5236F, 0.0F, 1.5708F));
		PartDefinition cube_r8 = legleftback.addOrReplaceChild("cube_r8", CubeListBuilder.create().texOffs(20, 135).addBox(-2.5F, -5.0F, -2.5F, 5.0F, 5.0F, 5.0F, new CubeDeformation(0.0F)),
				PartPose.offsetAndRotation(4.5F, 1.4375F, 1.4375F, -0.1339F, -0.4623F, 0.2934F));
		PartDefinition cube_r9 = legleftback.addOrReplaceChild("cube_r9", CubeListBuilder.create().texOffs(120, 125).addBox(-1.0F, -2.5F, -1.5F, 7.0F, 5.0F, 5.0F, new CubeDeformation(0.0F)),
				PartPose.offsetAndRotation(0.0F, 0.0F, -1.0F, 0.0631F, -0.3435F, -0.1855F));
		PartDefinition legrightback = partdefinition.addOrReplaceChild("legrightback", CubeListBuilder.create(), PartPose.offset(-9.0F, 19.5F, 9.5F));
		PartDefinition cube_r10 = legrightback.addOrReplaceChild("cube_r10", CubeListBuilder.create().texOffs(48, 125).addBox(-6.2357F, -2.4234F, -2.4058F, 7.0F, 5.0F, 5.0F, new CubeDeformation(0.0F)),
				PartPose.offsetAndRotation(-5.9375F, -1.25F, 2.125F, 0.5236F, 0.0F, -1.5708F));
		PartDefinition cube_r11 = legrightback.addOrReplaceChild("cube_r11", CubeListBuilder.create().texOffs(40, 135).addBox(-2.5F, -5.0F, -2.5F, 5.0F, 5.0F, 5.0F, new CubeDeformation(0.0F)),
				PartPose.offsetAndRotation(-4.5F, 1.4375F, 1.4375F, -0.1339F, 0.4623F, -0.2934F));
		PartDefinition cube_r12 = legrightback.addOrReplaceChild("cube_r12", CubeListBuilder.create().texOffs(132, 26).addBox(-6.0F, -2.5F, -1.5F, 7.0F, 5.0F, 5.0F, new CubeDeformation(0.0F)),
				PartPose.offsetAndRotation(0.0F, 0.0F, -1.0F, 0.0631F, 0.3435F, 0.1855F));
		PartDefinition body = partdefinition.addOrReplaceChild("body", CubeListBuilder.create(), PartPose.offset(0.0F, 24.0F, 0.0F));
		PartDefinition topshell = body.addOrReplaceChild("topshell",
				CubeListBuilder.create().texOffs(106, 75).addBox(-10.0F, -8.0F, -13.0F, 20.0F, 3.0F, 3.0F, new CubeDeformation(0.0F)).texOffs(62, 51).addBox(5.0F, -8.0F, -10.0F, 6.0F, 3.0F, 21.0F, new CubeDeformation(0.0F)).texOffs(106, 93)
						.addBox(-9.0F, -10.0F, -12.0F, 18.0F, 3.0F, 1.0F, new CubeDeformation(0.0F)).texOffs(54, 75).addBox(6.0F, -10.0F, -11.0F, 3.0F, 3.0F, 23.0F, new CubeDeformation(0.0F)).texOffs(116, 66)
						.addBox(-8.0F, -11.0F, -11.0F, 16.0F, 3.0F, 2.0F, new CubeDeformation(0.0F)).texOffs(46, 101).addBox(6.0F, -11.0F, -9.0F, 2.0F, 3.0F, 21.0F, new CubeDeformation(0.0F)).texOffs(0, 51)
						.addBox(-6.0F, -12.0F, -9.0F, 12.0F, 4.0F, 19.0F, new CubeDeformation(0.0F)).texOffs(132, 46).addBox(-6.0F, -11.0F, 10.0F, 12.0F, 3.0F, 2.0F, new CubeDeformation(0.0F)).texOffs(92, 101)
						.addBox(-8.0F, -11.0F, -9.0F, 2.0F, 3.0F, 21.0F, new CubeDeformation(0.0F)).texOffs(84, 0).addBox(-9.0F, -10.0F, -11.0F, 3.0F, 3.0F, 23.0F, new CubeDeformation(0.0F)).texOffs(106, 97)
						.addBox(-9.0F, -10.0F, 12.0F, 18.0F, 3.0F, 1.0F, new CubeDeformation(0.0F)).texOffs(0, 74).addBox(-11.0F, -8.0F, -10.0F, 6.0F, 3.0F, 21.0F, new CubeDeformation(0.0F)).texOffs(106, 81)
						.addBox(-10.0F, -8.0F, 11.0F, 20.0F, 3.0F, 3.0F, new CubeDeformation(0.0F)),
				PartPose.offset(0.0F, 0.0F, 0.0F));
		PartDefinition bottomshell = body.addOrReplaceChild("bottomshell",
				CubeListBuilder.create().texOffs(0, 98).addBox(8.0F, -6.0F, -10.0F, 2.0F, 4.0F, 21.0F, new CubeDeformation(0.0F)).texOffs(106, 87).addBox(-9.0F, -7.0F, -12.0F, 18.0F, 5.0F, 1.0F, new CubeDeformation(0.0F)).texOffs(0, 29)
						.addBox(-9.0F, -1.0F, -11.0F, 18.0F, -1.0F, 23.0F, new CubeDeformation(0.0F)).texOffs(0, 0).addBox(-9.0F, -7.0F, -11.0F, 18.0F, 5.0F, 24.0F, new CubeDeformation(0.0F)).texOffs(84, 26)
						.addBox(-10.0F, -6.0F, -10.0F, 3.0F, 4.0F, 21.0F, new CubeDeformation(0.0F)),
				PartPose.offset(0.0F, 0.0F, 0.0F));
		PartDefinition head = partdefinition.addOrReplaceChild("head", CubeListBuilder.create().texOffs(116, 51).addBox(-4.0F, -10.0F, -19.0F, 8.0F, 8.0F, 7.0F, new CubeDeformation(0.0F)), PartPose.offset(0.0F, 24.0F, 0.0F));
		return LayerDefinition.create(meshdefinition, 256, 256);
	}

	public void setupAnim(LivingEntityRenderState state) {
		float limbSwing = state.walkAnimationPos;
		float limbSwingAmount = state.walkAnimationSpeed;
		float ageInTicks = state.ageInTicks;
		float netHeadYaw = state.yRot;
		float headPitch = state.xRot;

	}
}
