package net.mcreator.enderitestuff.client.model;

import net.minecraft.resources.ResourceLocation;
import net.minecraft.client.renderer.entity.state.LivingEntityRenderState;
import net.minecraft.client.model.geom.builders.PartDefinition;
import net.minecraft.client.model.geom.builders.MeshDefinition;
import net.minecraft.client.model.geom.builders.LayerDefinition;
import net.minecraft.client.model.geom.builders.CubeListBuilder;
import net.minecraft.client.model.geom.builders.CubeDeformation;
import net.minecraft.client.model.geom.PartPose;
import net.minecraft.client.model.geom.ModelPart;
import net.minecraft.client.model.geom.ModelLayerLocation;
import net.minecraft.client.model.EntityModel;

// Made with Blockbench 4.12.4
// Exported for Minecraft version 1.17 or later with Mojang mappings
// Paste this class into your mod and generate all required imports
public class ModelFragGrenadeNew_Converted extends EntityModel<LivingEntityRenderState> {
	// This layer location should be baked with EntityRendererProvider.Context in
	// the entity renderer and passed into this model's constructor
	public static final ModelLayerLocation LAYER_LOCATION = new ModelLayerLocation(ResourceLocation.fromNamespaceAndPath("enderite__stuff", "model_frag_grenade_new_converted"), "main");
	public final ModelPart all;
	public final ModelPart top;
	public final ModelPart handle;
	public final ModelPart bodyangledx;
	public final ModelPart bodyangledz;
	public final ModelPart bodyangledy;
	public final ModelPart bodystraight;

	public ModelFragGrenadeNew_Converted(ModelPart root) {
		super(root);
		this.all = root.getChild("all");
		this.top = this.all.getChild("top");
		this.handle = this.top.getChild("handle");
		this.bodyangledx = this.all.getChild("bodyangledx");
		this.bodyangledz = this.all.getChild("bodyangledz");
		this.bodyangledy = this.all.getChild("bodyangledy");
		this.bodystraight = this.all.getChild("bodystraight");
	}

	public static LayerDefinition createBodyLayer() {
		MeshDefinition meshdefinition = new MeshDefinition();
		PartDefinition partdefinition = meshdefinition.getRoot();
		PartDefinition all = partdefinition.addOrReplaceChild("all", CubeListBuilder.create(), PartPose.offset(1.0F, 22.5F, -2.5F));
		PartDefinition top = all.addOrReplaceChild("top", CubeListBuilder.create(), PartPose.offset(0.0F, 0.0F, 0.0F));
		PartDefinition handle = top.addOrReplaceChild("handle", CubeListBuilder.create().texOffs(0, 14).addBox(-3.0F, -11.5F, 0.5F, 4.0F, 3.0F, 4.0F, new CubeDeformation(0.0F)), PartPose.offset(0.0F, 0.0F, 0.0F));
		PartDefinition bodyangledx = all.addOrReplaceChild("bodyangledx", CubeListBuilder.create(), PartPose.offset(2.0F, 3.5F, -0.5F));
		PartDefinition cube_r1 = bodyangledx.addOrReplaceChild("cube_r1", CubeListBuilder.create().texOffs(24, 26).addBox(-3.0F, -1.0F, -2.0F, 4.0F, 2.0F, 3.5F, new CubeDeformation(0.0F)),
				PartPose.offsetAndRotation(-2.0F, -10.5F, 5.5F, -0.7854F, 0.0F, 0.0F));
		PartDefinition cube_r2 = bodyangledx.addOrReplaceChild("cube_r2", CubeListBuilder.create().texOffs(10, 39).addBox(-3.0F, -2.0F, -1.0F, 4.0F, 3.5F, 2.0F, new CubeDeformation(0.0F)),
				PartPose.offsetAndRotation(-2.0F, -10.5F, 0.5F, -0.7854F, 0.0F, 0.0F));
		PartDefinition cube_r3 = bodyangledx.addOrReplaceChild("cube_r3", CubeListBuilder.create().texOffs(22, 39).addBox(-3.0F, -1.5F, -1.0F, 4.0F, 3.0F, 2.0F, new CubeDeformation(0.0F)),
				PartPose.offsetAndRotation(-2.0F, -3.5F, 5.5F, -0.7854F, 0.0F, 0.0F));
		PartDefinition cube_r4 = bodyangledx.addOrReplaceChild("cube_r4", CubeListBuilder.create().texOffs(10, 34).addBox(-3.0F, -1.0F, -1.5F, 4.0F, 2.0F, 3.0F, new CubeDeformation(0.0F)),
				PartPose.offsetAndRotation(-2.0F, -3.5F, 0.5F, -0.7854F, 0.0F, 0.0F));
		PartDefinition bodyangledz = all.addOrReplaceChild("bodyangledz", CubeListBuilder.create(), PartPose.offset(2.0F, 3.5F, -0.5F));
		PartDefinition cube_r5 = bodyangledz.addOrReplaceChild("cube_r5", CubeListBuilder.create().texOffs(28, 6).addBox(-1.0F, -2.0F, -1.0F, 2.0F, 3.5F, 4.0F, new CubeDeformation(0.0F)),
				PartPose.offsetAndRotation(-5.5F, -10.5F, 2.0F, 0.0F, 0.0F, 0.7854F));
		PartDefinition cube_r6 = bodyangledz.addOrReplaceChild("cube_r6", CubeListBuilder.create().texOffs(16, 20).addBox(-2.0F, -1.0F, -1.0F, 3.5F, 2.0F, 4.0F, new CubeDeformation(0.0F)),
				PartPose.offsetAndRotation(-0.5F, -10.5F, 2.0F, 0.0F, 0.0F, 0.7854F));
		PartDefinition cube_r7 = bodyangledz.addOrReplaceChild("cube_r7", CubeListBuilder.create().texOffs(28, 0).addBox(-1.5F, -1.0F, -1.0F, 3.0F, 2.0F, 4.0F, new CubeDeformation(0.0F)),
				PartPose.offsetAndRotation(-5.5F, -3.5F, 2.0F, 0.0F, 0.0F, 0.7854F));
		PartDefinition cube_r8 = bodyangledz.addOrReplaceChild("cube_r8", CubeListBuilder.create().texOffs(24, 32).addBox(-1.0F, -1.5F, -1.0F, 2.0F, 3.0F, 4.0F, new CubeDeformation(0.0F)),
				PartPose.offsetAndRotation(-0.5F, -3.5F, 2.0F, 0.0F, 0.0F, 0.7854F));
		PartDefinition bodyangledy = all.addOrReplaceChild("bodyangledy", CubeListBuilder.create(), PartPose.offset(2.0F, 3.5F, -0.5F));
		PartDefinition cube_r9 = bodyangledy.addOrReplaceChild("cube_r9", CubeListBuilder.create().texOffs(0, 38).addBox(-1.5F, -6.0F, -1.0F, 3.0F, 6.0F, 2.0F, new CubeDeformation(0.0F)),
				PartPose.offsetAndRotation(-5.5F, -4.0F, 5.5F, 0.0F, -0.7854F, 0.0F));
		PartDefinition cube_r10 = bodyangledy.addOrReplaceChild("cube_r10", CubeListBuilder.create().texOffs(32, 14).addBox(-1.0F, -6.0F, -1.5F, 2.0F, 6.0F, 3.0F, new CubeDeformation(0.0F)),
				PartPose.offsetAndRotation(-5.5F, -4.0F, 0.5F, 0.0F, -0.7854F, 0.0F));
		PartDefinition cube_r11 = bodyangledy.addOrReplaceChild("cube_r11", CubeListBuilder.create().texOffs(0, 29).addBox(-1.0F, -6.0F, -1.5F, 2.0F, 6.0F, 3.0F, new CubeDeformation(0.0F)),
				PartPose.offsetAndRotation(-0.5F, -4.0F, 5.5F, 0.0F, -0.7854F, 0.0F));
		PartDefinition cube_r12 = bodyangledy.addOrReplaceChild("cube_r12", CubeListBuilder.create().texOffs(36, 32).addBox(-1.5F, -6.0F, -1.0F, 3.0F, 6.0F, 2.0F, new CubeDeformation(0.0F)),
				PartPose.offsetAndRotation(-0.5F, -4.0F, 0.5F, 0.0F, -0.7854F, 0.0F));
		PartDefinition bodystraight = all.addOrReplaceChild("bodystraight",
				CubeListBuilder.create().texOffs(16, 0).addBox(2.0F, -2.0F, -2.0F, 2.25F, 6.0F, 4.0F, new CubeDeformation(0.0F)).texOffs(16, 10).addBox(-4.25F, -2.0F, -2.0F, 2.25F, 6.0F, 4.0F, new CubeDeformation(0.0F)).texOffs(0, 21)
						.addBox(-2.0F, -2.0F, -4.25F, 4.0F, 6.0F, 2.25F, new CubeDeformation(0.0F)).texOffs(0, 0).addBox(-2.0F, -4.0F, -2.0F, 4.0F, 10.25F, 4.0F, new CubeDeformation(0.0F)).texOffs(12, 26)
						.addBox(-2.0F, -2.0F, 2.0F, 4.0F, 6.0F, 2.25F, new CubeDeformation(0.0F)),
				PartPose.offset(-1.0F, -4.5F, 2.5F));
		return LayerDefinition.create(meshdefinition, 64, 64);
	}

	public void setupAnim(LivingEntityRenderState state) {
		float limbSwing = state.walkAnimationPos;
		float limbSwingAmount = state.walkAnimationSpeed;
		float ageInTicks = state.ageInTicks;
		float netHeadYaw = state.yRot;
		float headPitch = state.xRot;

	}

}
