package net.mcreator.enderitestuff.client.model;

import net.minecraft.resources.ResourceLocation;
import net.minecraft.client.renderer.entity.state.LivingEntityRenderState;
import net.minecraft.client.model.geom.builders.PartDefinition;
import net.minecraft.client.model.geom.builders.MeshDefinition;
import net.minecraft.client.model.geom.builders.LayerDefinition;
import net.minecraft.client.model.geom.builders.CubeListBuilder;
import net.minecraft.client.model.geom.builders.CubeDeformation;
import net.minecraft.client.model.geom.PartPose;
import net.minecraft.client.model.geom.ModelPart;
import net.minecraft.client.model.geom.ModelLayerLocation;
import net.minecraft.client.model.EntityModel;

// Made with Blockbench 4.12.4
// Exported for Minecraft version 1.17 or later with Mojang mappings
// Paste this class into your mod and generate all required imports
public class Modelspikes extends EntityModel<LivingEntityRenderState> {
	// This layer location should be baked with EntityRendererProvider.Context in
	// the entity renderer and passed into this model's constructor
	public static final ModelLayerLocation LAYER_LOCATION = new ModelLayerLocation(ResourceLocation.fromNamespaceAndPath("enderite__stuff", "modelspikes"), "main");
	public final ModelPart bb_main;

	public Modelspikes(ModelPart root) {
		super(root);
		this.bb_main = root.getChild("bb_main");
	}

	public static LayerDefinition createBodyLayer() {
		MeshDefinition meshdefinition = new MeshDefinition();
		PartDefinition partdefinition = meshdefinition.getRoot();
		PartDefinition bb_main = partdefinition.addOrReplaceChild("bb_main",
				CubeListBuilder.create().texOffs(2, 2).addBox(-5.0F, 4.0F, -4.0F, 2.0F, 4.0F, 0.0F, new CubeDeformation(0.0F)).texOffs(2, 2).addBox(-5.0F, 4.0F, 0.0F, 2.0F, 4.0F, 0.0F, new CubeDeformation(0.0F)).texOffs(2, 2)
						.addBox(-5.0F, 4.0F, 4.0F, 2.0F, 4.0F, 0.0F, new CubeDeformation(0.0F)).texOffs(2, 2).addBox(-1.0F, 4.0F, 0.0F, 2.0F, 4.0F, 0.0F, new CubeDeformation(0.0F)).texOffs(2, 2)
						.addBox(-1.0F, 4.0F, -4.0F, 2.0F, 4.0F, 0.0F, new CubeDeformation(0.0F)).texOffs(2, 2).addBox(-1.0F, 4.0F, 4.0F, 2.0F, 4.0F, 0.0F, new CubeDeformation(0.0F)).texOffs(2, 2)
						.addBox(3.0F, 4.0F, 4.0F, 2.0F, 4.0F, 0.0F, new CubeDeformation(0.0F)).texOffs(2, 2).addBox(3.0F, 4.0F, -4.0F, 2.0F, 4.0F, 0.0F, new CubeDeformation(0.0F)).texOffs(2, 2)
						.addBox(3.0F, 4.0F, 0.0F, 2.0F, 4.0F, 0.0F, new CubeDeformation(0.0F)),
				PartPose.offset(0.0F, 24.0F, 0.0F));
		PartDefinition cube_r1 = bb_main.addOrReplaceChild("cube_r1", CubeListBuilder.create().texOffs(3, 2).addBox(0.0F, -4.0F, 0.0F, 1.0F, 4.0F, 0.0F, new CubeDeformation(0.0F)), PartPose.offsetAndRotation(3.5F, 4.0F, -4.0F, 0.0F, 0.0F, 0.0F));
		PartDefinition cube_r2 = bb_main.addOrReplaceChild("cube_r2", CubeListBuilder.create().texOffs(3, 2).addBox(0.0F, -4.0F, 0.0F, 1.0F, 4.0F, 0.0F, new CubeDeformation(0.0F)), PartPose.offsetAndRotation(3.5F, 4.0F, 0.0F, 0.0F, 0.0F, 0.0F));
		PartDefinition cube_r3 = bb_main.addOrReplaceChild("cube_r3", CubeListBuilder.create().texOffs(3, 2).addBox(0.0F, -4.0F, 0.0F, 1.0F, 4.0F, 0.0F, new CubeDeformation(0.0F)), PartPose.offsetAndRotation(-0.5F, 4.0F, 4.0F, 0.0F, 0.0F, 0.0F));
		PartDefinition cube_r4 = bb_main.addOrReplaceChild("cube_r4", CubeListBuilder.create().texOffs(3, 2).addBox(0.0F, -4.0F, 0.0F, 1.0F, 4.0F, 0.0F, new CubeDeformation(0.0F)), PartPose.offsetAndRotation(-0.5F, 4.0F, -4.0F, 0.0F, 0.0F, 0.0F));
		PartDefinition cube_r5 = bb_main.addOrReplaceChild("cube_r5", CubeListBuilder.create().texOffs(3, 2).addBox(0.0F, -4.0F, 0.0F, 1.0F, 4.0F, 0.0F, new CubeDeformation(0.0F)), PartPose.offsetAndRotation(-0.5F, 4.0F, 0.0F, 0.0F, 0.0F, 0.0F));
		PartDefinition cube_r6 = bb_main.addOrReplaceChild("cube_r6", CubeListBuilder.create().texOffs(3, 2).addBox(0.0F, -4.0F, 0.0F, 1.0F, 4.0F, 0.0F, new CubeDeformation(0.0F)), PartPose.offsetAndRotation(-4.5F, 4.0F, 4.0F, 0.0F, 0.0F, 0.0F));
		PartDefinition cube_r7 = bb_main.addOrReplaceChild("cube_r7", CubeListBuilder.create().texOffs(3, 2).addBox(0.0F, -4.0F, 0.0F, 1.0F, 4.0F, 0.0F, new CubeDeformation(0.0F)), PartPose.offsetAndRotation(-4.5F, 4.0F, 0.0F, 0.0F, 0.0F, 0.0F));
		PartDefinition cube_r8 = bb_main.addOrReplaceChild("cube_r8",
				CubeListBuilder.create().texOffs(3, 2).addBox(-4.0F, -4.0F, -4.0F, 1.0F, 4.0F, 0.0F, new CubeDeformation(0.0F)).texOffs(3, 2).addBox(-4.0F, -4.0F, 0.0F, 1.0F, 4.0F, 0.0F, new CubeDeformation(0.0F)).texOffs(3, 2)
						.addBox(-4.0F, -4.0F, 4.0F, 1.0F, 4.0F, 0.0F, new CubeDeformation(0.0F)).texOffs(3, 2).addBox(0.0F, -4.0F, 0.0F, 1.0F, 4.0F, 0.0F, new CubeDeformation(0.0F)).texOffs(3, 2)
						.addBox(0.0F, -4.0F, -4.0F, 1.0F, 4.0F, 0.0F, new CubeDeformation(0.0F)).texOffs(3, 2).addBox(0.0F, -4.0F, 4.0F, 1.0F, 4.0F, 0.0F, new CubeDeformation(0.0F)).texOffs(3, 2)
						.addBox(4.0F, -4.0F, 0.0F, 1.0F, 4.0F, 0.0F, new CubeDeformation(0.0F)).texOffs(3, 2).addBox(4.0F, -4.0F, -4.0F, 1.0F, 4.0F, 0.0F, new CubeDeformation(0.0F)).texOffs(3, 2)
						.addBox(4.0F, -4.0F, 4.0F, 1.0F, 4.0F, 0.0F, new CubeDeformation(0.0F)),
				PartPose.offsetAndRotation(0.0F, 4.0F, 0.5F, 0.0F, 1.5708F, 0.0F));
		PartDefinition cube_r9 = bb_main.addOrReplaceChild("cube_r9", CubeListBuilder.create().texOffs(3, 2).addBox(0.0F, -4.0F, 0.0F, 1.0F, 4.0F, 0.0F, new CubeDeformation(0.0F)), PartPose.offsetAndRotation(-4.5F, 4.0F, -4.0F, 0.0F, 0.0F, 0.0F));
		PartDefinition cube_r10 = bb_main.addOrReplaceChild("cube_r10", CubeListBuilder.create().texOffs(3, 2).addBox(0.0F, -4.0F, 0.0F, 1.0F, 4.0F, 0.0F, new CubeDeformation(0.0F)), PartPose.offsetAndRotation(3.5F, 4.0F, 4.0F, 0.0F, 0.0F, 0.0F));
		PartDefinition cube_r11 = bb_main.addOrReplaceChild("cube_r11",
				CubeListBuilder.create().texOffs(2, 2).addBox(3.0F, -4.0F, 4.0F, 2.0F, 4.0F, 0.0F, new CubeDeformation(0.0F)).texOffs(2, 2).addBox(3.0F, -4.0F, -4.0F, 2.0F, 4.0F, 0.0F, new CubeDeformation(0.0F)).texOffs(2, 2)
						.addBox(3.0F, -4.0F, 0.0F, 2.0F, 4.0F, 0.0F, new CubeDeformation(0.0F)).texOffs(2, 2).addBox(-1.0F, -4.0F, 4.0F, 2.0F, 4.0F, 0.0F, new CubeDeformation(0.0F)).texOffs(2, 2)
						.addBox(-1.0F, -4.0F, -4.0F, 2.0F, 4.0F, 0.0F, new CubeDeformation(0.0F)).texOffs(2, 2).addBox(-1.0F, -4.0F, 0.0F, 2.0F, 4.0F, 0.0F, new CubeDeformation(0.0F)).texOffs(2, 2)
						.addBox(-5.0F, -4.0F, 4.0F, 2.0F, 4.0F, 0.0F, new CubeDeformation(0.0F)).texOffs(2, 2).addBox(-5.0F, -4.0F, 0.0F, 2.0F, 4.0F, 0.0F, new CubeDeformation(0.0F)).texOffs(2, 2)
						.addBox(-5.0F, -4.0F, -4.0F, 2.0F, 4.0F, 0.0F, new CubeDeformation(0.0F)),
				PartPose.offsetAndRotation(0.0F, 8.0F, 0.0F, 0.0F, 1.5708F, 0.0F));
		return LayerDefinition.create(meshdefinition, 16, 16);
	}

	public void setupAnim(LivingEntityRenderState state) {
		float limbSwing = state.walkAnimationPos;
		float limbSwingAmount = state.walkAnimationSpeed;
		float ageInTicks = state.ageInTicks;
		float netHeadYaw = state.yRot;
		float headPitch = state.xRot;

	}

}
