
/*
 *    MCreator note: This file will be REGENERATED on each build.
 */
package net.mcreator.enderitestuff.init;

import net.neoforged.neoforge.registries.DeferredRegister;
import net.neoforged.neoforge.registries.DeferredHolder;
import net.neoforged.neoforge.capabilities.RegisterCapabilitiesEvent;
import net.neoforged.neoforge.capabilities.Capabilities;
import net.neoforged.fml.common.EventBusSubscriber;
import net.neoforged.bus.api.SubscribeEvent;

import net.minecraft.world.level.block.entity.BlockEntityType;
import net.minecraft.world.level.block.Block;
import net.minecraft.core.registries.BuiltInRegistries;

import net.mcreator.enderitestuff.block.entity.LootCrateOPENBlockEntity;
import net.mcreator.enderitestuff.block.entity.LootCrateBlockEntity;
import net.mcreator.enderitestuff.block.entity.FireTrapBlockEntity;
import net.mcreator.enderitestuff.EnderiteStuffMod;

@EventBusSubscriber(bus = EventBusSubscriber.Bus.MOD)
public class EnderiteStuffModBlockEntities {
	public static final DeferredRegister<BlockEntityType<?>> REGISTRY = DeferredRegister.create(BuiltInRegistries.BLOCK_ENTITY_TYPE, EnderiteStuffMod.MODID);
	public static final DeferredHolder<BlockEntityType<?>, BlockEntityType<?>> FIRE_TRAP = register("fire_trap", EnderiteStuffModBlocks.FIRE_TRAP, FireTrapBlockEntity::new);
	public static final DeferredHolder<BlockEntityType<?>, BlockEntityType<?>> LOCKED_BARREL = register("locked_barrel", EnderiteStuffModBlocks.LOCKED_BARREL, LootCrateBlockEntity::new);
	public static final DeferredHolder<BlockEntityType<?>, BlockEntityType<?>> LOCKED_BARREL_OPEN = register("locked_barrel_open", EnderiteStuffModBlocks.LOCKED_BARREL_OPEN, LootCrateOPENBlockEntity::new);

	// Start of user code block custom block entities
	// End of user code block custom block entities
	private static DeferredHolder<BlockEntityType<?>, BlockEntityType<?>> register(String registryname, DeferredHolder<Block, Block> block, BlockEntityType.BlockEntitySupplier<?> supplier) {
		return REGISTRY.register(registryname, () -> new BlockEntityType(supplier, block.get()));
	}

	@SubscribeEvent
	public static void registerCapabilities(RegisterCapabilitiesEvent event) {
		event.registerBlockEntity(Capabilities.ItemHandler.BLOCK, FIRE_TRAP.get(), (blockEntity, side) -> ((FireTrapBlockEntity) blockEntity).getItemHandler());
		event.registerBlockEntity(Capabilities.ItemHandler.BLOCK, LOCKED_BARREL.get(), (blockEntity, side) -> ((LootCrateBlockEntity) blockEntity).getItemHandler());
		event.registerBlockEntity(Capabilities.ItemHandler.BLOCK, LOCKED_BARREL_OPEN.get(), (blockEntity, side) -> ((LootCrateOPENBlockEntity) blockEntity).getItemHandler());
	}
}
