package net.mcreator.enderitestuff.procedures;

import net.minecraft.world.level.LevelAccessor;
import net.minecraft.world.level.Level;
import net.minecraft.world.item.ItemStack;
import net.minecraft.world.entity.player.Player;
import net.minecraft.world.entity.LivingEntity;
import net.minecraft.world.entity.Entity;
import net.minecraft.sounds.SoundSource;
import net.minecraft.resources.ResourceLocation;
import net.minecraft.network.chat.Component;
import net.minecraft.core.registries.BuiltInRegistries;
import net.minecraft.core.BlockPos;

import net.mcreator.enderitestuff.init.EnderiteStuffModItems;

public class DungeonDoorOpeningProcedure {
	public static void execute(LevelAccessor world, double x, double y, double z, Entity entity) {
		if (entity == null)
			return;
		if ((entity instanceof LivingEntity _livEnt ? _livEnt.getMainHandItem() : ItemStack.EMPTY).getItem() == EnderiteStuffModItems.DUNGEON_KEY.get()) {
			world.destroyBlock(BlockPos.containing(x, y, z), false);
			world.destroyBlock(BlockPos.containing(x + 1, y, z + 1), false);
			world.destroyBlock(BlockPos.containing(x + 1, y, z - 1), false);
			world.destroyBlock(BlockPos.containing(x - 1, y, z + 1), false);
			world.destroyBlock(BlockPos.containing(x - 1, y, z - 1), false);
			world.destroyBlock(BlockPos.containing(x + 1, y, z), false);
			world.destroyBlock(BlockPos.containing(x, y, z + 1), false);
			world.destroyBlock(BlockPos.containing(x - 1, y, z), false);
			world.destroyBlock(BlockPos.containing(x, y, z - 1), false);
			if (world instanceof Level _level) {
				if (!_level.isClientSide()) {
					_level.playSound(null, BlockPos.containing(x, y, z), BuiltInRegistries.SOUND_EVENT.getValue(ResourceLocation.parse("block.vault.insert_item")), SoundSource.BLOCKS, 1, 1);
				} else {
					_level.playLocalSound(x, y, z, BuiltInRegistries.SOUND_EVENT.getValue(ResourceLocation.parse("block.vault.insert_item")), SoundSource.BLOCKS, 1, 1, false);
				}
			}
		} else {
			if (entity instanceof Player _player && !_player.level().isClientSide())
				_player.displayClientMessage(Component.literal("You need a key to open this"), true);
			if (world instanceof Level _level) {
				if (!_level.isClientSide()) {
					_level.playSound(null, BlockPos.containing(x, y, z), BuiltInRegistries.SOUND_EVENT.getValue(ResourceLocation.parse("block.vault.insert_item_fail")), SoundSource.BLOCKS, 1, 1);
				} else {
					_level.playLocalSound(x, y, z, BuiltInRegistries.SOUND_EVENT.getValue(ResourceLocation.parse("block.vault.insert_item_fail")), SoundSource.BLOCKS, 1, 1, false);
				}
			}
		}
	}
}
